Public Class frmSDLDetails
    Public KdNr As Integer = -1
    Public sdlNr As Integer = -1

    Dim DS_sperre As String
    Dim DS_sperreOLD As String
    Dim DS_sperreDatOLD As Date
    Dim bindingSDL As New cBinding("SDL")
    Dim SQL As New SQL

    Private Sub frmSDLDetails_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        If sdlNr <= 0 Then Me.Close() : MsgBox("Keine Leistung ausgewählt!") : Exit Sub
        If KdNr <= 0 Then Me.Close() : MsgBox("Keine KdNr ausgewählt!") : Exit Sub

        bindingSDL.initBinding("SELECT * FROM [KundenSDL] WHERE [KundenNr]=" & KdNr & " AND SDLNr=" & sdlNr, "KundenSDL")

        Label2.Text = KdNr
        Label4.Text = sdlNr

        ComboBox1.Items.Clear()
        ComboBox1.Items.Add(New VERAG_PROG_ALLGEMEIN.MyListItem("0 - Sperre aufgehoben", "0")) 'Sperre aufgehoben
        ComboBox1.Items.Add(New VERAG_PROG_ALLGEMEIN.MyListItem("1 - Sperre gesetzt", "1")) 'Sperre gesetzt
        ComboBox1.Items.Add(New VERAG_PROG_ALLGEMEIN.MyListItem("3 - Stopped for Post-Pay", "3")) 'Stopped for Post-Pay
        ComboBox1.SelectedIndex = 0

        bindingSDL.binddata(CheckBox1, "CheckState", bindingSDL.bindingSource, "Vertretungsvollmacht")
        bindingSDL.binddata(CheckBox2, "CheckState", bindingSDL.bindingSource, "Auszahlungsvollmacht")
        bindingSDL.binddata(CheckBox3, "CheckState", bindingSDL.bindingSource, "Finanzamtbestätigung")

        '    bindingSDL.binddata(txtMautDE_FlottenPIN, "Text", bindingSDL.bindingSource, "MautDE_FlottenPIN", "")
        '   bindingSDL.binddata(txtMautDEMasterPIN, "Text", bindingSDL.bindingSource, "MautDE_MasterPIN", "")
        '   bindingSDL.binddata(txtMautDE_BenutzerNr, "Text", bindingSDL.bindingSource, "MautDE_BenutzerNr", "")

        '  bindingSDL.binddata(txtMautAT_KartenNr, "Text", bindingSDL.bindingSource, "MautAT_KartenNr", "")

        'TODO: Diese Codezeile lädt Daten in die Tabelle "DsKundenSDL.KundenSDL". Sie können sie bei Bedarf verschieben oder entfernen.
        '  Me.KundenSDLTableAdapter.Fill(bindingSDL.bindingdataTable, KdNr, sdlNr)
        setCbo(bindingSDL.bindingdataTable.Rows(0).Item("Sperre").ToString)
        DS_sperreOLD = DirectCast(ComboBox1.SelectedItem, VERAG_PROG_ALLGEMEIN.MyListItem).Value
        TextBox1.Text = bindingSDL.bindingdataTable.Rows(0).Item("Sperrdatum").ToString
        If IsDate(TextBox1.Text) Then DS_sperreDatOLD = CDate(TextBox1.Text) ' : MsgBox("sperre: " & DS_sperreDatOLD)

        DateTimePicker1.Checked = bindingSDL.bindingdataTable.Rows(0).Item("Antragsdatum").ToString <> ""
        If DateTimePicker1.Checked Then
            DateTimePicker1.Value = bindingSDL.bindingdataTable.Rows(0).Item("Antragsdatum").ToString
        End If
        TextBox2.Text = bindingSDL.bindingdataTable.Rows(0).Item("Vermerk").ToString

        '   grpMautDE.Visible = (sdlNr = 201)
        '    GroupBox1.Visible = (sdlNr = 200)




    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        Me.Close()
    End Sub
    Sub setCbo(v)
        For Each i In ComboBox1.Items
            If DirectCast(i, VERAG_PROG_ALLGEMEIN.MyListItem).Value = v Then
                ComboBox1.SelectedItem = i
                Exit Sub
            End If
        Next
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Me.Cursor = Cursors.WaitCursor
        Me.Enabled = False
        Try
            If Not DateTimePicker1.Checked Then
                bindingSDL.bindingdataTable.Rows(0).Item("Antragsdatum") = DBNull.Value
            Else
                bindingSDL.bindingdataTable.Rows(0).Item("Antragsdatum") = DateTimePicker1.Value
            End If
            bindingSDL.bindingdataTable.Rows(0).Item("Vermerk") = TextBox2.Text
            bindingSDL.bindingdataTable.Rows(0).Item("Sperre") = DS_sperre
            '     MsgBox(bindingSDL.bindingtable.Rows(0).Item("Sperre"))
            If bindingSDL.bindingdataTable.Rows(0).Item("Sperre") = 0 Then
                bindingSDL.bindingdataTable.Rows(0).Item("Sperrdatum") = DBNull.Value
            Else
                bindingSDL.bindingdataTable.Rows(0).Item("Sperrdatum") = Now 'CDate(TextBox1.Text)
            End If

            bindingSDL.bindingdataTable.Rows(0).Item("Änderungsdatum") = Now
            bindingSDL.bindingdataTable.Rows(0).Item("Sachbearbeiter") = VERAG_PROG_ALLGEMEIN.cAllgemein.USRKURZNAME

            '    bindingSDL.bindingdataTable.Rows(0).Item("MautDE_FlottenPIN") = IIf(txtMautDE_FlottenPIN.Text <> "", txtMautDE_FlottenPIN.Text, DBNull.Value)
            '   bindingSDL.bindingdataTable.Rows(0).Item("MautDE_MasterPIN") = IIf(txtMautDEMasterPIN.Text <> "", txtMautDEMasterPIN.Text, DBNull.Value)
            '  bindingSDL.bindingdataTable.Rows(0).Item("MautDE_BenutzerNr") = IIf(txtMautDE_BenutzerNr.Text <> "", txtMautDE_BenutzerNr.Text, DBNull.Value)
            '   bindingSDL.bindingdataTable.Rows(0).Item("MautAT_KartenNr") = IIf(txtMautAT_KartenNr.Text <> "", txtMautAT_KartenNr.Text, DBNull.Value)


            bindingSDL.updateBinding()
            ' Me.BindingNavigator1.Validate()
            ' Me.KundenSDLBindingSource.EndEdit()
            'Me.KundenSDLTableAdapter.Update(bindingSDL.bindingdataTable)
            frmKundenblatt.initTABSDL_Leistungen()


            If sdlNr = 201 Then ' Bei Maut DE wird der Flotten und Master PIN neu gesetzt 
                If MsgBox("Sollen die folgenden Werte für alle Einträge übernommen werden? " & vbNewLine & vbNewLine & "Benutzer-Nr.: " & bindingSDL.bindingdataTable.Rows(0).Item("MautDE_BenutzerNr") & vbNewLine & "FlottenPIN: " & bindingSDL.bindingdataTable.Rows(0).Item("MautDE_FlottenPIN") & vbNewLine & "MasterPIN: " & bindingSDL.bindingdataTable.Rows(0).Item("MautDE_MasterPIN"), vbYesNo) = vbYes Then
                    SQL.doSQL("UPDATE [SDL] SET [FlottenPIN]='" & bindingSDL.bindingdataTable.Rows(0).Item("MautDE_FlottenPIN") & "',[MasterPIN]='" & bindingSDL.bindingdataTable.Rows(0).Item("MautDE_MasterPIN") & "' ,[BenutzerNr]='" & bindingSDL.bindingdataTable.Rows(0).Item("MautDE_BenutzerNr") & "' WHERE KundenNr=" & KdNr & " AND SDLNr=" & sdlNr & " ", "SDL")
                End If
            End If

            If sdlNr = 200 Then ' Bei Maut AT 
                If MsgBox("Sollen die folgenden Werte für alle Einträge übernommen werden? " & vbNewLine & vbNewLine & "KartenNr: " & bindingSDL.bindingdataTable.Rows(0).Item("MautAT_KartenNr"), vbYesNo) = vbYes Then
                    SQL.doSQL("UPDATE [SDL] SET [KartenNr]='" & bindingSDL.bindingdataTable.Rows(0).Item("MautAT_KartenNr") & "' WHERE KundenNr=" & KdNr & " AND SDLNr=" & sdlNr & " ", "SDL")
                End If
            End If


            If DS_sperreOLD = 0 And DS_sperreOLD <> DS_sperre Then
                If MsgBox("Sperre gesetzt - Sollten alle betroffenen Karten/Boxen gesperrt werden?", vbYesNoCancel) = vbYes Then
                    SQL.doSQL("UPDATE [SDL] SET Gesperrt = 1, GesperrtAm = GETDATE() WHERE KundenNr=" & KdNr & " AND SDLNr=" & sdlNr & " AND ( Gesperrt = 0 OR Gesperrt is null ) ", "SDL")
                End If
            End If
            If DS_sperreOLD <> 0 And DS_sperre = 0 Then
                If MsgBox("Sperre aufgehoben - Soll die Sperre für alle betroffenen Karten/Boxen aufgehoben werden?", vbYesNoCancel) = vbYes Then
                    SQL.doSQL("UPDATE [SDL] SET Gesperrt = 0 WHERE KundenNr=" & KdNr & " AND SDLNr=" & sdlNr & " AND (GesperrtAm is not null AND cast(GesperrtAm as date)='" & DS_sperreDatOLD.ToShortDateString & "') AND Gesperrt = 1", "SDL")
                End If
            End If



            Me.Close()
        Catch ex As Exception
            MsgBox(ex.Message)
            '  Me.KundenSDLBindingSource.ResetBindings(False)
        End Try
        Me.Cursor = Cursors.Default
        Me.Enabled = True
    End Sub


    Private Sub ComboBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ComboBox1.SelectedIndexChanged
        DS_sperre = DirectCast(ComboBox1.SelectedItem, VERAG_PROG_ALLGEMEIN.MyListItem).Value
        If ComboBox1.SelectedIndex > 0 Then
            TextBox1.Text = Now.ToShortDateString
        Else
            TextBox1.Text = ""
        End If

    End Sub
End Class